# generated by datamodel-codegen:
#   filename:  account_calendars.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class AccountCalendar(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[204], repr=False)
    """
    the ID of the account associated with this calendar
    """

    name: Optional[str] = Field(None, examples=['Department of Chemistry'])
    """
    the name of the account associated with this calendar
    """

    parent_account_id: Optional[int] = Field(None, examples=[1], repr=False)
    """
    the account's parent ID, or null if this is the root account
    """

    root_account_id: Optional[int] = Field(None, examples=[1], repr=False)
    """
    the ID of the root account, or null if this is the root account
    """

    visible: Optional[bool] = Field(None, examples=[True])
    """
    whether this calendar is visible to users
    """

    auto_subscribe: Optional[bool] = Field(None, examples=[False], repr=False)
    """
    whether users see this calendar's events without needing to manually add it
    """

    sub_account_count: Optional[int] = Field(None, examples=[0], repr=False)
    """
    number of this account's direct sub-accounts
    """

    asset_string: Optional[str] = Field(None, examples=['account_4'], repr=False)
    """
    Asset string of the account
    """

    type: Optional[str] = Field(None, examples=['account'], repr=False)
    """
    Object type
    """

    calendar_event_url: Optional[str] = Field(
        None, examples=['/accounts/2/calendar_events/%7B%7B%20id%20%7D%7D']
    )
    """
    url to get full detailed events
    """

    can_create_calendar_events: Optional[bool] = Field(
        None, examples=[True], repr=False
    )
    """
    whether the user can create calendar events
    """

    create_calendar_event_url: Optional[str] = Field(
        None, examples=['/accounts/2/calendar_events'], repr=False
    )
    """
    API path to create events for the account
    """

    new_calendar_event_url: Optional[str] = Field(
        None, examples=['/accounts/6/calendar_events/new'], repr=False
    )
    """
    url to open the more options event editor
    """

