# generated by datamodel-codegen:
#   filename:  account_notifications.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class AccountNotification(CanvasBaseModel):
    subject: Optional[str] = Field(None, examples=['Attention Students'])
    """
    The subject of the notifications
    """

    message: Optional[str] = Field(
        None, examples=['This is a test of the notification system.'], repr=False
    )
    """
    The message to be sent in the notification.
    """

    start_at: Optional[datetime] = Field(
        None, examples=['2013-08-28T23:59:00-06:00'], repr=False
    )
    """
    When to send out the notification.
    """

    end_at: Optional[datetime] = Field(
        None, examples=['2013-08-29T23:59:00-06:00'], repr=False
    )
    """
    When to expire the notification.
    """

    icon: Optional[str] = Field(None, examples=['information'], repr=False)
    """
    The icon to display with the message.  Defaults to warning.
    """

    roles: Optional[list[str]] = Field(
        None, examples=[['StudentEnrollment']], repr=False
    )
    """
    (Deprecated) The roles to send the notification to.  If roles is not passed it defaults to all roles
    """

    role_ids: Optional[list[int]] = Field(None, examples=[[1]], repr=False)
    """
    The roles to send the notification to.  If roles is not passed it defaults to all roles
    """

