# generated by datamodel-codegen:
#   filename:  announcement_external_feeds.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class ExternalFeed(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[5], repr=False)
    """
    The ID of the feed
    """

    display_name: Optional[str] = Field(None, examples=['My Blog'])
    """
    The title of the feed, pulled from the feed itself. If the feed hasn't yet been pulled, a temporary name will be synthesized based on the URL
    """

    url: Optional[str] = Field(
        None, examples=['http://example.com/myblog.rss'], repr=False
    )
    """
    The HTTP/HTTPS URL to the feed
    """

    header_match: Optional[str] = Field(None, examples=['pattern'], repr=False)
    """
    If not null, only feed entries whose title contains this string will trigger new posts in Canvas
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2012-06-01T00:00:00-06:00'], repr=False
    )
    """
    When this external feed was added to Canvas
    """

    verbosity: Optional[str] = Field(None, examples=['truncate'], repr=False)
    """
    The verbosity setting determines how much of the feed's content is imported into Canvas as part of the posting. 'link_only' means that only the title and a link to the item. 'truncate' means that a summary of the first portion of the item body will be used. 'full' means that the full item body will be used.
    """

