# generated by datamodel-codegen:
#   filename:  authentications_log.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class AuthenticationEvent(CanvasBaseModel):
    created_at: Optional[datetime] = Field(None, examples=['2012-07-19T15:00:00-06:00'])
    """
    timestamp of the event
    """

    event_type: Optional[str] = Field(None, examples=['login'])
    """
    authentication event type ('login' or 'logout')
    """

    pseudonym_id: Optional[int] = Field(None, examples=[9478])
    """
    ID of the pseudonym (login) associated with the event
    """

    account_id: Optional[int] = Field(None, examples=[2319], repr=False)
    """
    ID of the account associated with the event. will match the account_id in the associated pseudonym.
    """

    user_id: Optional[int] = Field(None, examples=[362], repr=False)
    """
    ID of the user associated with the event will match the user_id in the associated pseudonym.
    """

