# generated by datamodel-codegen:
#   filename:  collaborations.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class Collaboration(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[43])
    """
    The unique identifier for the collaboration
    """

    collaboration_type: Optional[str] = Field(
        None, examples=['Microsoft Office'], repr=False
    )
    """
    A name for the type of collaboration
    """

    document_id: Optional[str] = Field(None, examples=['oinwoenfe8w8ef_onweufe89fef'])
    """
    The collaboration document identifier for the collaboration provider
    """

    user_id: Optional[int] = Field(None, examples=[92], repr=False)
    """
    The canvas id of the user who created the collaboration
    """

    context_id: Optional[int] = Field(None, examples=[77], repr=False)
    """
    The canvas id of the course or group to which the collaboration belongs
    """

    context_type: Optional[str] = Field(None, examples=['Course'], repr=False)
    """
    The canvas type of the course or group to which the collaboration belongs
    """

    url: Optional[str] = Field(None, repr=False)
    """
    The LTI launch url to view collaboration.
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2012-06-01T00:00:00-06:00'], repr=False
    )
    """
    The timestamp when the collaboration was created
    """

    updated_at: Optional[datetime] = Field(
        None, examples=['2012-06-01T00:00:00-06:00'], repr=False
    )
    """
    The timestamp when the collaboration was last modified
    """

    description: Optional[str] = Field(None, repr=False)
    title: Optional[str] = Field(None, repr=False)
    type: Optional[str] = Field(
        None, examples=['ExternalToolCollaboration'], repr=False
    )
    """
    Another representation of the collaboration type
    """

    update_url: Optional[str] = Field(None, repr=False)
    """
    The LTI launch url to edit the collaboration
    """

    user_name: Optional[str] = Field(None, examples=['John Danger'], repr=False)
    """
    The name of the user who owns the collaboration
    """



class Collaborator(CanvasBaseModel):
    id: int = Field(..., examples=[12345])
    """
    The unique user or group identifier for the collaborator.
    """

    type: Optional[str] = Field(None, examples=['user'], repr=False)
    """
    The type of collaborator (e.g. 'user' or 'group').
    """

    name: Optional[str] = Field(None, examples=['Don Draper'])
    """
    The name of the collaborator.
    """

