# generated by datamodel-codegen:
#   filename:  comm_messages.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class CommMessage(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[42])
    """
    The ID of the CommMessage.
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2013-03-19T21:00:00Z'], repr=False
    )
    """
    The date and time this message was created
    """

    sent_at: Optional[datetime] = Field(
        None, examples=['2013-03-20T22:42:00Z'], repr=False
    )
    """
    The date and time this message was sent
    """

    workflow_state: Optional[str] = Field(None, examples=['sent'], repr=False)
    """
    The workflow state of the message. One of 'created', 'staged', 'sending', 'sent', 'bounced', 'dashboard', 'cancelled', or 'closed'
    """

    from_: Optional[str] = Field(
        None, alias='from', examples=['notifications@example.com'], repr=False
    )
    """
    The address that was put in the 'from' field of the message
    """

    from_name: Optional[str] = Field(None, examples=['Instructure Canvas'], repr=False)
    """
    The display name for the from address
    """

    to: Optional[str] = Field(None, examples=['someone@example.com'], repr=False)
    """
    The address the message was sent to:
    """

    reply_to: Optional[str] = Field(
        None, examples=['notifications+specialdata@example.com'], repr=False
    )
    """
    The reply_to header of the message
    """

    subject: Optional[str] = Field(None, examples=['example subject line'])
    """
    The message subject
    """

    body: Optional[str] = Field(
        None, examples=['This is the body of the message'], repr=False
    )
    """
    The plain text body of the message
    """

    html_body: Optional[str] = Field(
        None,
        examples=['<html><body>This is the body of the message</body></html>'],
        repr=False,
    )
    """
    The HTML body of the message.
    """

