# generated by datamodel-codegen:
#   filename:  content_exports.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class ContentExport(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[101])
    """
    the unique identifier for the export
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2014-01-01T00:00:00Z'], repr=False
    )
    """
    the date and time this export was requested
    """

    export_type: Optional[str] = Field(None, examples=['common_cartridge'])
    """
    the type of content migration: 'common_cartridge' or 'qti'
    """

    attachment: Optional[File] = Field(
        None,
        examples=[
            {
                'url': 'https://example.com/api/v1/attachments/789?download_frd=1&verifier=bG9sY2F0cyEh'
            }
        ],
        repr=False,
    )
    """
    attachment api object for the export package (not present before the export completes or after it becomes unavailable for download.)
    """

    progress_url: Optional[str] = Field(
        None, examples=['https://example.com/api/v1/progress/4'], repr=False
    )
    """
    The api endpoint for polling the current progress
    """

    user_id: Optional[int] = Field(None, examples=[4])
    """
    The ID of the user who started the export
    """

    workflow_state: Optional[str] = Field(None, examples=['exported'], repr=False)
    """
    Current state of the content migration: created exporting exported failed
    """


from .files import File  # noqa: E402