# generated by datamodel-codegen:
#   filename:  e_pub_exports.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class EpubExport(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[101])
    """
    the unique identifier for the export
    """

    created_at: Optional[datetime] = Field(None, examples=['2014-01-01T00:00:00Z'])
    """
    the date and time this export was requested
    """

    attachment: Optional[File] = Field(
        None,
        examples=[
            {
                'url': 'https://example.com/api/v1/attachments/789?download_frd=1&verifier=bG9sY2F0cyEh'
            }
        ],
    )
    """
    attachment api object for the export ePub (not present until the export completes)
    """

    progress_url: Optional[str] = Field(
        None, examples=['https://example.com/api/v1/progress/4']
    )
    """
    The api endpoint for polling the current progress
    """

    user_id: Optional[int] = Field(None, examples=[4])
    """
    The ID of the user who started the export
    """

    workflow_state: Optional[str] = Field(None, examples=['exported'])
    """
    Current state of the ePub export: created exporting exported generating generated failed
    """



class CourseEpubExport(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[101])
    """
    the unique identifier for the course
    """

    name: Optional[str] = Field(None, examples=['Maths 101'])
    """
    the name for the course
    """

    epub_export: Optional[EpubExport] = Field(None, repr=False)
    """
    ePub export API object
    """


from .files import File  # noqa: E402