# generated by datamodel-codegen:
#   filename:  enrollment_terms.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Any, Optional

from pydantic import Field

from . import CanvasBaseModel



class EnrollmentTerm(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=['1'])
    """
    The unique identifier for the enrollment term.
    """

    sis_term_id: Optional[str] = Field(None, examples=['Sp2014'], repr=False)
    """
    The SIS id of the term. Only included if the user has permission to view SIS information.
    """

    sis_import_id: Optional[int] = Field(None, examples=[34], repr=False)
    """
    the unique identifier for the SIS import. This field is only included if the user has permission to manage SIS information.
    """

    name: Optional[str] = Field(None, examples=['Spring 2014'])
    """
    The name of the term.
    """

    start_at: Optional[datetime] = Field(
        None, examples=['2014-01-06T08:00:00-05:00'], repr=False
    )
    """
    The datetime of the start of the term.
    """

    end_at: Optional[datetime] = Field(
        None, examples=['2014-05-16T05:00:00-04:00'], repr=False
    )
    """
    The datetime of the end of the term.
    """

    workflow_state: Optional[str] = Field(None, examples=['active'], repr=False)
    """
    The state of the term. Can be 'active' or 'deleted'.
    """

    overrides: Optional[dict[str, Any]] = Field(
        None,
        examples=[
            {
                'StudentEnrollment': {
                    'start_at': '2014-01-07T08:00:00-05:00',
                    'end_at': '2014-05-14T05:00:00-04:0',
                }
            }
        ],
        repr=False,
    )
    """
    Term date overrides for specific enrollment types
    """

    course_count: Optional[int] = Field(None, examples=['80'], repr=False)
    """
    The number of courses in the term (available via include)
    """



class EnrollmentTermsList(CanvasBaseModel):
    enrollment_terms: Optional[list[EnrollmentTerm]] = Field(None, examples=[[]])
    """
    a paginated list of all terms in the account
    """

