# generated by datamodel-codegen:
#   filename:  files.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class File(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[569], repr=False)
    uuid: Optional[str] = Field(
        None, examples=['SUj23659sdfASF35h265kf352YTdnC4'], repr=False
    )
    folder_id: Optional[int] = Field(None, examples=[4207], repr=False)
    display_name: Optional[str] = Field(None, examples=['file.txt'])
    filename: Optional[str] = Field(None, examples=['file.txt'], repr=False)
    content_type: Optional[str] = Field(
        None, alias='content-type', examples=['text/plain'], repr=False
    )
    url: Optional[str] = Field(
        None,
        examples=[
            'http://www.example.com/files/569/download?download_frd=1&verifier=c6HdZmxOZa0Fiin2cbvZeI8I5ry7yqD7RChQzb6P'
        ],
        repr=False,
    )
    size: Optional[int] = Field(None, examples=[43451], repr=False)
    """
    file size in bytes
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    updated_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    unlock_at: Optional[datetime] = Field(
        None, examples=['2012-07-07T14:58:50Z'], repr=False
    )
    locked: Optional[bool] = Field(None, examples=[False], repr=False)
    hidden: Optional[bool] = Field(None, examples=[False], repr=False)
    lock_at: Optional[datetime] = Field(
        None, examples=['2012-07-20T14:58:50Z'], repr=False
    )
    hidden_for_user: Optional[bool] = Field(None, examples=[False], repr=False)
    visibility_level: Optional[str] = Field(None, examples=['course'], repr=False)
    """
    Changes who can access the file. Valid options are 'inherit' (the default), 'course', 'institution', and 'public'. Only valid in course endpoints.
    """

    thumbnail_url: Optional[str] = Field(None, repr=False)
    modified_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    mime_class: Optional[str] = Field(None, examples=['html'], repr=False)
    """
    simplified content-type mapping
    """

    media_entry_id: Optional[str] = Field(
        None, examples=['m-3z31gfpPf129dD3sSDF85SwSDFnwe'], repr=False
    )
    """
    identifier for file in third-party transcoding service
    """

    locked_for_user: Optional[bool] = Field(None, examples=[False], repr=False)
    lock_info: Optional[LockInfo] = Field(None, repr=False)
    lock_explanation: Optional[str] = Field(
        None,
        examples=['This assignment is locked until September 1 at 12:00am'],
        repr=False,
    )
    preview_url: Optional[str] = Field(None, repr=False)
    """
    optional: url to the document preview. This url is specific to the user making the api call. Only included in submission endpoints.
    """



class Folder(CanvasBaseModel):
    context_type: Optional[str] = Field(None, examples=['Course'], repr=False)
    context_id: Optional[int] = Field(None, examples=[1401], repr=False)
    files_count: Optional[int] = Field(None, examples=[0], repr=False)
    position: Optional[int] = Field(None, examples=[3], repr=False)
    updated_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    folders_url: Optional[str] = Field(
        None,
        examples=['https://www.example.com/api/v1/folders/2937/folders'],
        repr=False,
    )
    files_url: Optional[str] = Field(
        None, examples=['https://www.example.com/api/v1/folders/2937/files'], repr=False
    )
    full_name: Optional[str] = Field(None, examples=['course files/11folder'])
    lock_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    id: Optional[int] = Field(None, examples=[2937], repr=False)
    folders_count: Optional[int] = Field(None, examples=[0], repr=False)
    name: Optional[str] = Field(None, examples=['11folder'], repr=False)
    parent_folder_id: Optional[int] = Field(None, examples=[2934], repr=False)
    created_at: Optional[datetime] = Field(
        None, examples=['2012-07-06T14:58:50Z'], repr=False
    )
    unlock_at: Optional[datetime] = Field(None, repr=False)
    hidden: Optional[bool] = Field(None, examples=[False], repr=False)
    hidden_for_user: Optional[bool] = Field(None, examples=[False], repr=False)
    locked: Optional[bool] = Field(None, examples=[True], repr=False)
    locked_for_user: Optional[bool] = Field(None, examples=[False], repr=False)
    for_submissions: Optional[bool] = Field(None, examples=[False], repr=False)
    """
    If true, indicates this is a read-only folder containing files submitted to assignments
    """



class UsageRights(CanvasBaseModel):
    legal_copyright: Optional[str] = Field(
        None, examples=['(C) 2014 Incom Corporation Ltd'], repr=False
    )
    """
    Copyright line for the file
    """

    use_justification: Optional[str] = Field(None, examples=['creative_commons'])
    """
    Justification for using the file in a Canvas course. Valid values are 'own_copyright', 'public_domain', 'used_by_permission', 'fair_use', 'creative_commons'
    """

    license: Optional[str] = Field(None, examples=['cc_by_sa'])
    """
    License identifier for the file.
    """

    license_name: Optional[str] = Field(
        None, examples=['CC Attribution Share-Alike'], repr=False
    )
    """
    Readable license name
    """

    message: Optional[str] = Field(None, examples=['4 files updated'], repr=False)
    """
    Explanation of the action performed
    """

    file_ids: Optional[list[int]] = Field(None, examples=[[1, 2, 3]], repr=False)
    """
    List of ids of files that were updated
    """



class License(CanvasBaseModel):
    id: Optional[str] = Field(None, examples=['cc_by_sa'])
    """
    a short string identifying the license
    """

    name: Optional[str] = Field(None, examples=['CC Attribution ShareAlike'])
    """
    the name of the license
    """

    url: Optional[str] = Field(
        None, examples=['http://creativecommons.org/licenses/by-sa/4.0'], repr=False
    )
    """
    a link to the license text
    """


from .assignments import LockInfo  # noqa: E402