# generated by datamodel-codegen:
#   filename:  grade_change_log.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class GradeChangeEventLinks(CanvasBaseModel):
    assignment: Optional[int] = Field(None, examples=[2319])
    """
    ID of the assignment associated with the event
    """

    course: Optional[int] = Field(None, examples=[2319])
    """
    ID of the course associated with the event. will match the context_id in the associated assignment if the context type for the assignment is a course
    """

    student: Optional[int] = Field(None, examples=[2319])
    """
    ID of the student associated with the event. will match the user_id in the associated submission.
    """

    grader: Optional[int] = Field(None, examples=[2319])
    """
    ID of the grader associated with the event. will match the grader_id in the associated submission.
    """

    page_view: Optional[str] = Field(
        None, examples=['e2b76430-27a5-0131-3ca1-48e0eb13f29b']
    )
    """
    ID of the page view during the event if it exists.
    """



class GradeChangeEvent(CanvasBaseModel):
    id: Optional[str] = Field(None, examples=['e2b76430-27a5-0131-3ca1-48e0eb13f29b'])
    """
    ID of the event.
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2012-07-19T15:00:00-06:00'], repr=False
    )
    """
    timestamp of the event
    """

    event_type: Optional[str] = Field(None, examples=['grade_change'])
    """
    GradeChange event type
    """

    excused_after: Optional[bool] = Field(None, examples=[True], repr=False)
    """
    Boolean indicating whether the submission was excused after the change.
    """

    excused_before: Optional[bool] = Field(None, examples=[False], repr=False)
    """
    Boolean indicating whether the submission was excused before the change.
    """

    grade_after: Optional[str] = Field(None, examples=['8'])
    """
    The grade after the change.
    """

    grade_before: Optional[str] = Field(None, examples=['8'])
    """
    The grade before the change.
    """

    graded_anonymously: Optional[bool] = Field(None, examples=[True], repr=False)
    """
    Boolean indicating whether the student name was visible when the grade was given. Could be null if the grade change record was created before this feature existed.
    """

    version_number: Optional[str] = Field(None, examples=['1'], repr=False)
    """
    Version Number of the grade change submission.
    """

    request_id: Optional[str] = Field(
        None, examples=['e2b76430-27a5-0131-3ca1-48e0eb13f29b'], repr=False
    )
    """
    The unique request id of the request during the grade change.
    """

    links: Optional[GradeChangeEventLinks] = Field(None, repr=False)
