# generated by datamodel-codegen:
#   filename:  grading_periods.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class GradingPeriod(CanvasBaseModel):
    id: int = Field(..., examples=[1023])
    """
    The unique identifier for the grading period.
    """

    title: Optional[str] = Field(None, examples=['First Block'])
    """
    The title for the grading period.
    """

    start_date: datetime = Field(..., examples=['2014-01-07T15:04:00Z'], repr=False)
    """
    The start date of the grading period.
    """

    end_date: datetime = Field(..., examples=['2014-05-07T17:07:00Z'], repr=False)
    """
    The end date of the grading period.
    """

    close_date: Optional[datetime] = Field(
        None, examples=['2014-06-07T17:07:00Z'], repr=False
    )
    """
    Grades can only be changed before the close date of the grading period.
    """

    weight: Optional[int] = Field(None, examples=['33.33'], repr=False)
    """
    A weight value that contributes to the overall weight of a grading period set which is used to calculate how much assignments in this period contribute to the total grade
    """

    is_closed: Optional[bool] = Field(None, examples=[True], repr=False)
    """
    If true, the grading period's close_date has passed.
    """

