# generated by datamodel-codegen:
#   filename:  late_policy.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Optional

from pydantic import Field, confloat

from . import CanvasBaseModel



class LateSubmissionInterval(Enum):
    hour = 'hour'
    day = 'day'


class LatePolicy(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[123])
    """
    the unique identifier for the late policy
    """

    course_id: int = Field(..., examples=[123], repr=False)
    """
    the unique identifier for the course
    """

    missing_submission_deduction_enabled: Optional[bool] = Field(
        False, examples=[True], repr=False
    )
    """
    whether to enable missing submission deductions
    """

    missing_submission_deduction: Optional[confloat(ge=0.0, le=100.0)] = Field(
        0, examples=[12.34], repr=False
    )
    """
    amount of percentage points to deduct
    """

    late_submission_deduction_enabled: Optional[bool] = Field(
        False, examples=[True], repr=False
    )
    """
    whether to enable late submission deductions
    """

    late_submission_deduction: Optional[confloat(ge=0.0, le=100.0)] = Field(
        0, examples=[12.34], repr=False
    )
    """
    amount of percentage points to deduct per late_submission_interval
    """

    late_submission_interval: Optional[LateSubmissionInterval] = Field(
        'day', examples=['hour'], repr=False
    )
    """
    time interval for late submission deduction
    """

    late_submission_minimum_percent_enabled: Optional[bool] = Field(
        False, examples=[True], repr=False
    )
    """
    whether to enable late submission minimum percent
    """

    late_submission_minimum_percent: Optional[confloat(ge=0.0, le=100.0)] = Field(
        0, examples=[12.34], repr=False
    )
    """
    the minimum score a submission can receive in percentage points
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2012-07-01T23:59:00-06:00'], repr=False
    )
    """
    the time at which this late policy was originally created
    """

    updated_at: Optional[datetime] = Field(
        None, examples=['2012-07-01T23:59:00-06:00'], repr=False
    )
    """
    the time at which this late policy was last modified in any way
    """

