# generated by datamodel-codegen:
#   filename:  planner.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class PlannerNote(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[234])
    """
    The ID of the planner note
    """

    title: Optional[str] = Field(None, examples=['Bring books tomorrow'])
    """
    The title for a planner note
    """

    description: Optional[str] = Field(
        None,
        examples=['I need to bring books tomorrow for my course on biology'],
        repr=False,
    )
    """
    The description of the planner note
    """

    user_id: Optional[int] = Field(None, examples=[1578941], repr=False)
    """
    The id of the associated user creating the planner note
    """

    workflow_state: Optional[str] = Field(None, examples=['active'], repr=False)
    """
    The current published state of the planner note
    """

    course_id: Optional[int] = Field(None, examples=[1578941], repr=False)
    """
    The course that the note is in relation too, if applicable
    """

    todo_date: Optional[datetime] = Field(None, examples=['2017-05-09T10:12:00Z'])
    """
    The datetime of when the planner note should show up on their planner
    """

    linked_object_type: Optional[str] = Field(None, examples=['assignment'], repr=False)
    """
    the type of the linked learning object
    """

    linked_object_id: Optional[int] = Field(None, examples=[131072], repr=False)
    """
    the id of the linked learning object
    """

    linked_object_html_url: Optional[str] = Field(
        None,
        examples=['https://canvas.example.com/courses/1578941/assignments/131072'],
        repr=False,
    )
    """
    the Canvas web URL of the linked learning object
    """

    linked_object_url: Optional[str] = Field(
        None,
        examples=[
            'https://canvas.example.com/api/v1/courses/1578941/assignments/131072'
        ],
        repr=False,
    )
    """
    the API URL of the linked learning object
    """



class PlannerOverride(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[234])
    """
    The ID of the planner override
    """

    plannable_type: Optional[str] = Field(None, examples=['Assignment'], repr=False)
    """
    The type of the associated object for the planner override
    """

    plannable_id: Optional[int] = Field(None, examples=[1578941])
    """
    The id of the associated object for the planner override
    """

    user_id: Optional[int] = Field(None, examples=[1578941], repr=False)
    """
    The id of the associated user for the planner override
    """

    assignment_id: Optional[int] = Field(None, examples=[1578941], repr=False)
    """
    The id of the plannable's associated assignment, if it has one
    """

    workflow_state: Optional[str] = Field(None, examples=['published'], repr=False)
    """
    The current published state of the item, synced with the associated object
    """

    marked_complete: Optional[bool] = Field(None, examples=[False])
    """
    Controls whether or not the associated plannable item is marked complete on the planner
    """

    dismissed: Optional[bool] = Field(None, examples=[False], repr=False)
    """
    Controls whether or not the associated plannable item shows up in the opportunities list
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2017-05-09T10:12:00Z'], repr=False
    )
    """
    The datetime of when the planner override was created
    """

    updated_at: Optional[datetime] = Field(
        None, examples=['2017-05-09T10:12:00Z'], repr=False
    )
    """
    The datetime of when the planner override was updated
    """

    deleted_at: Optional[datetime] = Field(
        None, examples=['2017-05-15T12:12:00Z'], repr=False
    )
    """
    The datetime of when the planner override was deleted, if applicable
    """

