# generated by datamodel-codegen:
#   filename:  poll_sessions.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Any, Optional

from pydantic import Field

from . import CanvasBaseModel



class PollSession(CanvasBaseModel):
    id: int = Field(..., examples=[1023])
    """
    The unique identifier for the poll session.
    """

    poll_id: int = Field(..., examples=[55])
    """
    The id of the Poll this poll session is associated with
    """

    course_id: int = Field(..., examples=[1111], repr=False)
    """
    The id of the Course this poll session is associated with
    """

    course_section_id: Optional[int] = Field(None, examples=[444], repr=False)
    """
    The id of the Course Section this poll session is associated with
    """

    is_published: Optional[bool] = Field(None, examples=['true'], repr=False)
    """
    Specifies whether or not this poll session has been published for students to participate in.
    """

    has_public_results: Optional[bool] = Field(None, examples=['true'], repr=False)
    """
    Specifies whether the results are viewable by students.
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2014-01-07T15:16:18Z'], repr=False
    )
    """
    The time at which the poll session was created.
    """

    results: Optional[dict[str, Any]] = Field(
        None, examples=[{'144': 10, '145': 3, '146': 27, '147': 8}], repr=False
    )
    """
    The results of the submissions of the poll. Each key is the poll choice id, and the value is the count of submissions.
    """

    poll_submissions: Optional[PollSubmission] = Field(None, repr=False)
    """
    If the poll session has public results, this will return an array of all submissions, viewable by both students and teachers. If the results are not public, for students it will return their submission only.
    """


from .poll_submissions import PollSubmission  # noqa: E402