# generated by datamodel-codegen:
#   filename:  polls.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Any, Optional

from pydantic import Field

from . import CanvasBaseModel



class Poll(CanvasBaseModel):
    id: int = Field(..., examples=[1023])
    """
    The unique identifier for the poll.
    """

    question: str = Field(
        ...,
        examples=[
            'What do you consider most important to your learning in this course?'
        ],
    )
    """
    The question/title of the poll.
    """

    description: Optional[str] = Field(
        None,
        examples=[
            'This poll is to determine what priorities the students in the course have.'
        ],
        repr=False,
    )
    """
    A short description of the poll.
    """

    created_at: Optional[datetime] = Field(
        None, examples=['2014-01-07T15:16:18Z'], repr=False
    )
    """
    The time at which the poll was created.
    """

    user_id: Optional[int] = Field(None, examples=[105], repr=False)
    """
    The unique identifier for the user that created the poll.
    """

    total_results: Optional[dict[str, Any]] = Field(
        None, examples=[{'543': 20, '544': 5, '545': 17}], repr=False
    )
    """
    An aggregate of the results of all associated poll sessions, with the poll choice id as the key, and the aggregated submission count as the value.
    """

