# generated by datamodel-codegen:
#   filename:  quiz_assignment_overrides.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class QuizAssignmentOverride(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[1])
    """
    ID of the assignment override, unless this is the base construct, in which case the 'id' field is omitted.
    """

    due_at: Optional[datetime] = Field(None, examples=['2014-02-21T06:59:59Z'])
    """
    The date after which any quiz submission is considered late.
    """

    unlock_at: Optional[datetime] = Field(None, examples=[None])
    """
    Date when the quiz becomes available for taking.
    """

    lock_at: Optional[datetime] = Field(None, examples=['2014-02-21T06:59:59Z'])
    """
    When the quiz will stop being available for taking. A value of null means it can always be taken.
    """

    title: Optional[str] = Field(None, examples=['Project X'])
    """
    Title of the section this assignment override is for, if any.
    """

    base: Optional[bool] = Field(None, examples=[True])
    """
    If this property is present, it means that dates in this structure are not based on an assignment override, but are instead for all students.
    """



class QuizAssignmentOverrideSet(CanvasBaseModel):
    quiz_id: Optional[str] = Field(None, examples=['1'])
    """
    ID of the quiz those dates are for.
    """

    due_dates: Optional[QuizAssignmentOverride] = Field(None, repr=False)
    """
    An array of quiz assignment overrides. For students, this array will always contain a single item which is the set of dates that apply to that student. For teachers and staff, it may contain more.
    """

    all_dates: Optional[QuizAssignmentOverride] = Field(None, repr=False)
    """
    An array of all assignment overrides active for the quiz. This is visible only to teachers and staff.
    """



class QuizAssignmentOverrideSetContainer(CanvasBaseModel):
    quiz_assignment_overrides: Optional[list[QuizAssignmentOverrideSet]] = None
    """
    The QuizAssignmentOverrideSet
    """

