# generated by datamodel-codegen:
#   filename:  sections.json
#   timestamp: 2024-09-02T14:02:23+00:00

from __future__ import annotations

from datetime import datetime
from typing import Optional

from pydantic import Field

from . import CanvasBaseModel



class Section(CanvasBaseModel):
    id: Optional[int] = Field(None, examples=[1])
    """
    The unique identifier for the section.
    """

    name: Optional[str] = Field(None, examples=['Section A'])
    """
    The name of the section.
    """

    sis_section_id: Optional[str] = Field(None, examples=['s34643'], repr=False)
    """
    The sis id of the section. This field is only included if the user has permission to view SIS information.
    """

    integration_id: Optional[str] = Field(None, examples=['3452342345'], repr=False)
    """
    Optional: The integration ID of the section. This field is only included if the user has permission to view SIS information.
    """

    sis_import_id: Optional[int] = Field(None, examples=[47], repr=False)
    """
    The unique identifier for the SIS import if created through SIS. This field is only included if the user has permission to manage SIS information.
    """

    course_id: Optional[int] = Field(None, examples=[7])
    """
    The unique Canvas identifier for the course in which the section belongs
    """

    sis_course_id: Optional[str] = Field(None, examples=[7], repr=False)
    """
    The unique SIS identifier for the course in which the section belongs. This field is only included if the user has permission to view SIS information.
    """

    start_at: Optional[datetime] = Field(
        None, examples=['2012-06-01T00:00:00-06:00'], repr=False
    )
    """
    the start date for the section, if applicable
    """

    end_at: Optional[datetime] = Field(None, repr=False)
    """
    the end date for the section, if applicable
    """

    restrict_enrollments_to_section_dates: Optional[bool] = Field(None, repr=False)
    """
    Restrict user enrollments to the start and end dates of the section
    """

    nonxlist_course_id: Optional[int] = Field(None, repr=False)
    """
    The unique identifier of the original course of a cross-listed section
    """

    total_students: Optional[int] = Field(None, examples=[13], repr=False)
    """
    optional: the total number of active and invited students in the section
    """

